#include "../cvutil/cvutil.h"
#include "../../intel/mkl/mkl.h"
#include <iostream>


using namespace std;
// UUsƂ̌ŗLlƕz̑ȉ~̊֌W
// ƂΏ̍s񂪂ƂȂȉ~́As̑ŗLl1Ƃƒa2/1, Za2/2 ƂȂB
// ̊֌ẂuΏ̍sɑ΂ȉ~v̂̂łCuUsUsɑ΂镪z̑ȉ~vƂ͊֌WȂB
// ہC傫ȌŗLl͂̕U傫ȕzŁuΏ̍sɑ΂ȉ~v̊֌Ŵ܂܎gƒaEZa͒ZȂĂ܂D
// uUsUsɑ΂镪z̑ȉ~v߂ɂ́A܂UUs̋ts߁CtšŗLlEŗLxNggD
// ́AUsUšŗLl߂Ēa2*2AZa2*1ƂĂ悢


int main()
{
	//  +:摜ŉE@
	//  -:摜ŉEオ
	mkl::Matrix S(2, 2), Sinv(2, 2);
	S(0, 0) = 1000;	S(0, 1) = -500;
	S(1, 0) = -500;	S(1, 1) = 1000;

	S.invert22(Sinv);

	mkl::Vector eval1(4), eval2(4);
	mkl::Matrix evec1(4, 2), evec2(4, 2);
	mkl::symmat::calculateEigens22WithLowAccuracy(S, S, Sinv, Sinv, eval1, eval2, evec1, evec2);

	cout << "S" << endl;									S.print();
	cout << "Sinv" << endl;								Sinv.print();
	cout << "eigen value(1)" << endl;			eval1.print();
	cout << "eigen value(2)" << endl;			eval2.print();
	cout << "eigen vector(1)" << endl;		evec1.print();
	cout << "eigen vector(2)" << endl;		evec2.print();

	getchar();

	opencv::cvutil::Image<IPL_DEPTH_8U> img(600, 600, 3);
	img.clear();

	const int u_offset = img.getWidth() / 2, v_offset = img.getHeight() / 2;
	for(int v = - v_offset; v < v_offset; ++ v){
		for(int u = - u_offset; u < u_offset; ++ u){
			if(Sinv(0, 0) * u * u + (Sinv(0, 1) + Sinv(1, 0)) * u * v + Sinv(1, 1) * v * v < 9.0){
				img(u+u_offset, v+v_offset, opencv::cvutil::RED) = 255;
			}

			/*
			if(S(0, 0) * u * u + (S(0, 1) + S(1, 0)) * u * v + S(1, 1) * v * v < 9.0){
				img(u+u_offset, v+v_offset, opencv::cvutil::GREEN) = 255;
			}
			*/
		}
	}

	img.show("img");
	cvWaitKey();

	return 0;
}